searchData={"items":[{"type":"module","title":"AshDefaultSort","doc":"","ref":"AshDefaultSort.html"},{"type":"macro","title":"AshDefaultSort.default_sort/1","doc":"","ref":"AshDefaultSort.html#default_sort/1"},{"type":"module","title":"AshDefaultSort.HasManySort.Transformer","doc":"","ref":"AshDefaultSort.HasManySort.Transformer.html"},{"type":"function","title":"AshDefaultSort.HasManySort.Transformer.after?/1","doc":"Callback implementation for  Spark.Dsl.Transformer.after?/1 .","ref":"AshDefaultSort.HasManySort.Transformer.html#after?/1"},{"type":"function","title":"AshDefaultSort.HasManySort.Transformer.after_compile?/0","doc":"Callback implementation for  Spark.Dsl.Transformer.after_compile?/0 .","ref":"AshDefaultSort.HasManySort.Transformer.html#after_compile?/0"},{"type":"function","title":"AshDefaultSort.HasManySort.Transformer.before?/1","doc":"Callback implementation for  Spark.Dsl.Transformer.before?/1 .","ref":"AshDefaultSort.HasManySort.Transformer.html#before?/1"},{"type":"module","title":"AshDefaultSort.Info","doc":"","ref":"AshDefaultSort.Info.html"},{"type":"function","title":"AshDefaultSort.Info.default_sort_except/1","doc":"List of read actions to exclude","ref":"AshDefaultSort.Info.html#default_sort_except/1"},{"type":"function","title":"AshDefaultSort.Info.default_sort_except!/1","doc":"List of read actions to exclude","ref":"AshDefaultSort.Info.html#default_sort_except!/1"},{"type":"function","title":"AshDefaultSort.Info.default_sort_has_many_sort/1","doc":"The sort to apply when a has_many relationship has no sort","ref":"AshDefaultSort.Info.html#default_sort_has_many_sort/1"},{"type":"function","title":"AshDefaultSort.Info.default_sort_has_many_sort!/1","doc":"The sort to apply when a has_many relationship has no sort","ref":"AshDefaultSort.Info.html#default_sort_has_many_sort!/1"},{"type":"function","title":"AshDefaultSort.Info.default_sort_include_primary_read?/1","doc":"Whether to apply to the primary read action as well","ref":"AshDefaultSort.Info.html#default_sort_include_primary_read?/1"},{"type":"function","title":"AshDefaultSort.Info.default_sort_options/1","doc":"default_sort DSL options\n\nReturns a map containing the and any configured or default values.","ref":"AshDefaultSort.Info.html#default_sort_options/1"},{"type":"function","title":"AshDefaultSort.Info.default_sort_sort/1","doc":"The sort to apply when Ash.Query has no sort","ref":"AshDefaultSort.Info.html#default_sort_sort/1"},{"type":"function","title":"AshDefaultSort.Info.default_sort_sort!/1","doc":"The sort to apply when Ash.Query has no sort","ref":"AshDefaultSort.Info.html#default_sort_sort!/1"},{"type":"module","title":"AshDefaultSort.Sort.Preparation","doc":"","ref":"AshDefaultSort.Sort.Preparation.html"},{"type":"function","title":"AshDefaultSort.Sort.Preparation.init/1","doc":"Callback implementation for  Ash.Resource.Preparation.init/1 .","ref":"AshDefaultSort.Sort.Preparation.html#init/1"},{"type":"function","title":"AshDefaultSort.Sort.Preparation.prepare/3","doc":"Callback implementation for  Ash.Resource.Preparation.prepare/3 .","ref":"AshDefaultSort.Sort.Preparation.html#prepare/3"},{"type":"module","title":"AshDefaultSort.Sort.Transformer","doc":"","ref":"AshDefaultSort.Sort.Transformer.html"},{"type":"function","title":"AshDefaultSort.Sort.Transformer.after?/1","doc":"Callback implementation for  Spark.Dsl.Transformer.after?/1 .","ref":"AshDefaultSort.Sort.Transformer.html#after?/1"},{"type":"function","title":"AshDefaultSort.Sort.Transformer.after_compile?/0","doc":"Callback implementation for  Spark.Dsl.Transformer.after_compile?/0 .","ref":"AshDefaultSort.Sort.Transformer.html#after_compile?/0"},{"type":"function","title":"AshDefaultSort.Sort.Transformer.before?/1","doc":"Callback implementation for  Spark.Dsl.Transformer.before?/1 .","ref":"AshDefaultSort.Sort.Transformer.html#before?/1"},{"type":"function","title":"AshDefaultSort.Sort.Transformer.transform/1","doc":"Callback implementation for  Spark.Dsl.Transformer.transform/1 .","ref":"AshDefaultSort.Sort.Transformer.html#transform/1"},{"type":"extras","title":"AshDefaultSort","doc":"# AshDefaultSort\n\nConfigure a default sort to apply when a read action or a has_many relationship has no sort.","ref":"readme.html"},{"type":"extras","title":"Installation - AshDefaultSort","doc":"Add `ash_default_sort` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:ash_default_sort, \"~> 0.2.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - AshDefaultSort","doc":"```elixir\ndefmodule Post do\n  use Ash.Resource,\n    data_layer: Ash.DataLayer.Postgres,\n    extensions: [AshDefaultSort]\n\n  relationships do\n    has_many :comments, Comment\n    has_many :tags, Tag do\n      sort [id: :asc]\n    end\n  end\n\n  actions do\n    read :read do\n      primary? true\n    end\n  \n    read :read_sorted do\n      prepare build(sort: [id: :desc])\n    end\n\n    read :read_all do\n    end\n\n    read :read_every do\n    end\n  end\n\n  default_sort do\n    sort [like_count: :desc, created_at: :desc]\n    has_many_sort [id: :desc]\n    include_primary_read? false\n    except [:read_all]\n  end\nend\n```\n\nIn the example above, `[like_count: :desc, created_at: :desc]` is applied to `read_every`.\n\nThis is because `read` is excluded by `include_primary_read? false`, `read_sorted` is not affected because it already includes a `sort`, and `read_all` is excluded by the `except` option.\n\nAnd the `default_sort` for `comments` is set to `[id: :desc]` because `has_many_sort` is present, and `comments` has no `sort` or `default_sort` options.","ref":"readme.html#usage"},{"type":"extras","title":"License - AshDefaultSort","doc":"MIT","ref":"readme.html#license"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.1"}}